import 'dart:convert';

import 'package:bui_component/JsonFormComponent/json_schema.dart';
import 'package:example/Constants/AppColors.dart';
import 'package:flutter/material.dart';

class ButtonView extends StatefulWidget {
  @override
  _ButtonViewState createState() => _ButtonViewState();
}

class _ButtonViewState extends State<ButtonView> {
  String form = json.encode({
    'fields': [
      {
        'apiKeyValue': 'dueDate',
        'key': 'dueDate',
        'type': 'date',
        'label': 'Start Date',
        'required': true,
        'keyboardType': 'number',
        'validator': 'text',
        'value': "",
      },
      {
        'apiKeyValue': 'dueDate',
        'key': 'dueDate',
        'type': 'date',
        'label': 'End Date',
        'required': true,
        'keyboardType': 'number',
        'validator': 'text',
        'value': "",
      },
      {
        'apiKeyValue': 'statusid',
        'key': 'Status',
        'type': 'select',
        'label': 'Status',
        'required': true,
        'keyboardType': 'text',
        'validator': 'text',
        'value': '1',
        'items': [
          {'label': 'New', 'value': '1'},
          {'label': 'Active', 'value': '2'},
          {'label': 'Inactive', 'value': '3'},
        ]
      },
      /*  {
        'apiKeyValue': 'dueDate',
        'key': 'dueDate',
        'type': 'date',
        'label': 'End Date',
        'required': true,
        'keyboardType': 'number',
        'validator': 'text',
        'value': "",
      },
     {
        'key': 'checkbox1',
        'type': 'checkbox',
        'label': 'Checkbox test',
        'items': [
          {
            'label': "New",
            'value': true,
          },
          {
            'label': "Folow",
            'value': false,
          },
          {
            'label': "Hot",
            'value': false,
          },
          {
            'label': "Lost",
            'value': false,
          },
          {
            'label': "Won",
            'value': false,
          },
        ]
      },


      {
        'apiKeyValue': 'statusid',
        'key': 'Status',
        'type': 'select',
        'label': 'Project Tag',
        'required': true,
        'keyboardType': 'text',
        'validator': 'text',
        'value': null,
        'items': [
          {'label': 'Won', 'value': '4'},
          {'label': 'Lost', 'value': '5'},
          {'label': 'Hot', 'value': '6'},
        ]
      },
      {
        'apiKeyValue': 'statusid',
        'key': 'Status',
        'type': 'select',
        'label': 'Area',
        'required': true,
        'keyboardType': 'text',
        'validator': 'text',
        'value': null,
        'items': [
          {'label': 'East', 'value': '7'},
          {'label': 'West', 'value': '8'},
          {'label': 'North', 'value': '9'},
          {'label': 'South', 'value': '10'},
        ]
      },*/
    ]
  });
  dynamic response;

  Map decorations = {
    'input1': InputDecoration(
      prefixIcon: Icon(Icons.email),
      border: OutlineInputBorder(),
    ),
    'FirstName': InputDecoration(
      prefixIcon: Icon(Icons.person),
      border: OutlineInputBorder(),
    ),
    'Id': InputDecoration(
      prefixIcon: Icon(Icons.phone_android),
      border: OutlineInputBorder(),
    ),
    'tareatext1': InputDecoration(
      prefixIcon: Icon(Icons.description),
      border: OutlineInputBorder(),
    ),
    'password1': InputDecoration(
        prefixIcon: Icon(Icons.lock), border: OutlineInputBorder()),
  };

  Map validations = {'password1': validationExample};
  Map errorText = {
    'input1': "Error Value",
    'password1': "Enter the Password",
  };

  static String validationExample(field, value) {
    String pattern =
        r'^(?=.*?[A-Z])(?=.*?[a-z])(?=.*?[0-9])(?=.*?[!@#\$&*~]).{8,}$';
    RegExp regExp = new RegExp(pattern);

    if (value.isEmpty) {
      return 'Please enter some text';
    }
    if (value.length < 8) {
      return 'Password is too short';
    }

    if (!regExp.hasMatch(value)) {
      return 'Password contains Minimum 1 Upper case Minimum 1 lowercase Minimum 1 Numeric Number Minimum 1 Special Character Common Allow Character ( ! @ # \$ & * ~ )';
    }
    return null;
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
        appBar: AppBar(
          title: Text("Filter"),
          backgroundColor: AppColors.primaryColor,
        ),
        body: ListView(
          children: [
            new JsonSchema(
              decorations: decorations,
              form: form,
              validations: validations,
              errorMessages: errorText,
              onChanged: (dynamic response) {
                this.response = response;
              },
              actionSave: (data) {
                var jsonObj = {
                  for (int i = 0; i < data['fields'].length; i++)
                    json.encode(
                        data['fields'][i]['value'].toString().trimLeft())
                };
                print("Date value====" + jsonObj.toString());
              },
              buttonSave: true,
              actionCancel: () {
                Navigator.pop(context);
              },
            ),
          ],
        ));
  }
}
